-
Notifications
You must be signed in to change notification settings - Fork 0
/
Copy pathfile_search.cpp
105 lines (77 loc) · 2.28 KB
/
file_search.cpp
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
/* Problem Link - https://www.interviewbit.com/problems/file-search/
Problem Description
You are given an assignment to sort out the files of your department today.
A file contains various records. Each record has an (ID, Parent ID).
To make your task easier, you decided to separate records into different sets.
If a set contains a record with (ID, Parent ID) - (X, Y), then both X and Y must be present in the set.
There are A records. You are also given a 2D array B of dimensions N x 2,
where each row is record's (ID, Parent ID).
You have to find the maximum number of sets you can divide the records into.
Problem Constraints
1 <= A, N <= 105
1 <= B[i][0], B[i][1] <= A
There can be duplicate records.
There can be two records (X, Y) and (Y, X).
Input Format
The first argument is the integer A.
The second argument is the 2D integer array B.
Output Format
Return a single integer denoting the maximum number of sets you can break the record into.
Example Input
Input 1:
A = 4
B = [[1, 2], [3, 4]]
Input 2:
A = 4
B = [[1, 2], [3, 4], [2, 4]]
Example Output
Output 1:
2
Output 2:
1
Example Explanation
Explanation 1:
We can create two sets (1, 2), (3, 4). Since, (1, 2) need to be together and (3, 4).
Explanation 2:
We can only have 1 set because (1, 2) need to be together (2, 4) need to be together.
Hence, (1, 2, 4) need to be together. Similarly, (1, 2, 3, 4) need to be together. Therefore, the answer is 1.
*/
#include <bits/stdc++.h>
using namespace std;
int find(vector<int>& dsu, int a)
{
if(dsu[a] == a) return dsu[a];
else dsu[a] = find(dsu, dsu[a]);
return dsu[a];
}
void join(int a, int b, vector<int>& dsu, vector<int>& rank)
{
int pa = find(dsu, a);
int pb = find(dsu, b);
if(pa == pb) return;
else if(rank[pa] > rank[pb]) dsu[pb] = pa;
else if(rank[pb] > rank[pa]) dsu[pa] = pb;
else if(rank[pa] == rank[pb])
{
dsu[pa] = pb;
rank[pa]++;
}
}
int Solution::breakRecords(int A, vector<vector<int> > &B) {
vector<int> dsu(A+1);
vector<int> rank(A+1, 1);
for(int i=1; i<=A; i++)
{
dsu[i]=i;
}
for(int i=0; i<B.size(); i++)
{
join(B[i][0], B[i][1], dsu, rank);
}
unordered_set<int> s;
for(int i=1; i<=A; i++)
{
s.insert(find(dsu, i));
}
return s.size();
}